using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using IposiGospodDemo.Context;
using IposiGospodDemo.Helpers;
using Microsoft.EntityFrameworkCore;
using Npgsql;
using ReactiveUI;

namespace IposiGospodDemo.ViewModels;

public class MySponsorshipWindowViewModel : ViewModelBase
{
    
    private ObservableCollection<Sponsorship> _sponsorships;

    public ObservableCollection<Sponsorship> Sponsorships 
    {
        get => _sponsorships;
        set => this.RaiseAndSetIfChanged(ref _sponsorships, value);
    }
    
    public Charity RunnerCharity { get; set; }
    
    public decimal TotalAmount { get; set; }

    public MySponsorshipWindowViewModel()
    {
        Sponsorships = new(DbHelper.Database.Sponsorships
            .Include(s => s.Registration)
            .Where(s => s.Registration.RunnerId == Session.Runner.RunnerId).ToList());

        TotalAmount = Sponsorships?.Sum(s => s.Amount) ?? 0;
        List<Registration> regs =  new (DbHelper.Database.Registrations.Where(r => r.RunnerId == Session.Runner.RunnerId));
        Console.WriteLine(regs.Count);
        Console.WriteLine(regs);
        var registration = DbHelper.Database.Registrations
            .Include(r => r.Charity) // Убедитесь, что Charity загружается
            .FirstOrDefault(r => r.RunnerId == Session.Runner.RunnerId);

        RunnerCharity = registration?.Charity; // Предотвращаем NullReferenceException
        
        Console.WriteLine("Runner Charity = " + RunnerCharity.CharityName);
    }
}