using System;
using System.Linq;
using Avalonia;
using Avalonia.Controls;
using Avalonia.Interactivity;
using Avalonia.Markup.Xaml;
using IposiGospodDemo.Context;
using IposiGospodDemo.Helpers;
using Microsoft.EntityFrameworkCore;

namespace IposiGospodDemo.Views;

public partial class LoginWindow : Window
{
    public LoginWindow()
    {
        InitializeComponent();
    }

    private void GoBack_OnClick(object? sender, RoutedEventArgs e)
    {
        new MainWindow().Show();
        Close();
    }

    private void Login_OnClick(object? sender, RoutedEventArgs e)
    {
        User user = DbHelper.Database.Users
            .Include(u => u.Role)
            .Single(u => 
                EmailBox.Text != null && u.Email == EmailBox.Text.Trim() &&
                PasswordBox.Text != null && u.Password == PasswordBox.Text.Trim());

        Session.User = user;
        
        switch (user.Role.RoleId)
        {
            case 'R':
                Session.Runner = DbHelper.Database.Runners.Single(r => r.EmailNavigation.Email == user.Email);
                new RunnerMenuWindow().Show();
                break;
            case 'C':
                new CoordinatorMenuWindow().Show();
                break;
            case 'A':
                new AdministratorMenuWindow().Show();
                break;
        }
        Close();
    }

    private void Cancel_OnClick(object? sender, RoutedEventArgs e)
    {
        new MainWindow().Show();
        Close();
    }
}